from marshmallow import Schema, fields, post_load

from workspaces.capability.schema import CapabilityEvent


class CapabilityEventSchema(Schema):
    """
    Default schema for serializing CapabilityEvents.
    """

    # TODO: determine shape of Capability Events
    request_name = fields.String()
    request_id = fields.String()
    event_type = fields.Method("get_type", deserialize="load_type")

    def get_type(self) -> str:
        raise NotImplementedError

    def load_type(self, name: str):
        raise NotImplementedError

    @post_load
    def make_event(self, data, **kwargs):
        return CapabilityEvent(**data)


capability_event = CapabilityEventSchema()
